// alien.C
// Alien class functions
// Tony Stornetta

#include <iostream.h>
#include "flyingObjects.h"

Alien::Alien (int x, int y)
{
	x_pos = x;
	y_pos = y;
	cycle = 0;
	dying = 0;
	cout << "\x1b[" << y_pos << ";" << x_pos <<
		"H_x_\x1b[B\x1b[3D\\H/\x1b[B\x1b[2Dv" << flush;
}

void Alien::move (enum DIR direction)
{
	switch (direction)
	{
	case LEFT:
		x_pos--;
		if (dying)
			cout << "\x1b[" << y_pos << ";" << x_pos - 1 <<
				"H_(^)_\x1b[B\x1b[5D\\***/\x1b[B\x1b[4D\\_/" <<
				flush;
		else
			cout << "\x1b[" << y_pos << ";" << x_pos <<
			   "H_x_ \x1b[B\x1b[4D\\H/ \x1b[B\x1b[3Dv " << flush;
		break;
	case RIGHT:
		if (dying)
			cout << "\x1b[" << y_pos << ";" << x_pos <<
				"H_(^)_\x1b[B\x1b[5D\\***/\x1b[B\x1b[4D\\_/" <<
				flush;
		else
			cout << "\x1b[" << y_pos << ";" << x_pos <<
			   "H _x_\x1b[B\x1b[4D \\H/\x1b[B\x1b[3D v" << flush;
		x_pos++;
		break;
	case UP:
		y_pos--;
		cout << "\x1b[" << y_pos << ";" << x_pos <<
			"H_x_\x1b[B\x1b[3D\\H/\x1b[B\x1b[3D v \x1b[B\x1b[2D "
			<< flush;
		break;
	case DOWN:
		y_pos++;
		cout << "\x1b[" << (y_pos-1) << ";" << x_pos <<
			"H   \x1b[B\x1b[3D_x_\x1b[B\x1b[3D\\H/\x1b[B\x1b[2Dv"
			<< flush;
		break;
	}
	cycle = 1 - cycle;
}

int Alien::getCycle()
{
	return cycle;
}

int Alien::check(int x, int y)
{
	return ((x == x_pos + 1 && y == y_pos + 2) ||
	   (x >= x_pos && x <= x_pos + 2 && y >= y_pos && y <= y_pos + 1));
}

Alien::~Alien()
{
	cout << "\x1b[" << y_pos << ";" << x_pos - 1 <<
		"H     \x1b[B\x1b[5D     \x1b[B\x1b[4D   " << flush;
}
