// main.C
// Main function
// Tony Stornetta

#define _SYS_TTOLD_INCLUDED

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <sgtty.h>
#include <sys/time.h>
#include <signal.h>
#include "flyingObjects.h"
#include "level.h"

#include <unistd.h>
#ifndef __NeXT__
//#include <sys/filio.h>
#endif

#include <sys/ttold.h>

#define ERR (-1)

//extern int ioctl (int, int, ...);

// Globals
int FlyingObject::screenWidth = 80;
int FlyingObject::screenLength = 24;
int Level::screenWidth = 80;
int Level::screenLength = 24;
int Level::currentLevel = 0;
int Level::score = 0;
int Level::lives = 3;
int Level::justDied = 0;
long Level::interval = 1000;

int sigdone;

void newsig(int)
{
  sigdone = 1;
}

void stall(long intval)
{
  static struct itimerval old, newval = { 0L, 0L, 0L, 0L };

  sigdone = 0;
  newval.it_value.tv_usec = intval;
  signal (SIGALRM, newsig);
  setitimer (ITIMER_REAL, &newval, &old);

  while (!sigdone)
    ;
}

void quit (char *errstg)
{
	cout << "Error with " << errstg << endl;
	exit (-1);
}

void setraw()
{
	struct sgttyb arg;

	if (ioctl(fileno(stdin), TIOCGETP, &arg) == ERR)
		quit("ioctl-get");
	arg.sg_flags |= RAW;
	arg.sg_flags &= (~ECHO);
	if (ioctl(fileno(stdin), TIOCSETP, &arg) == ERR)
		quit ("ioctl");
}

void restore()
{
	struct sgttyb arg;

	if (ioctl(fileno(stdin), TIOCGETP, &arg) == ERR)
		quit ("ioctl");
	arg.sg_flags &= (~RAW);
	arg.sg_flags |= ECHO;
	if (ioctl(fileno(stdin), TIOCSETP, &arg) == ERR)
		quit ("ioctl");
}

int kbhit()
{
	struct sgttyb arg;
	void *x = &arg;
	int *i;

	i = (int *)x;
	if (ioctl(fileno(stdin), FIONREAD, &arg) == ERR)
		quit ("ioctl");

	return *i;
}

char getch()
{
	return getchar();
}

int initScreen(int screenWidth, int screenLength)
{
	int middleX = screenWidth/2;
	int middleY = screenLength/2;
	char string[] = "Time Invaders ";
	int i=0;
        char c;

	cout << "\x1b[2J\x1b[" << middleY - 2 << ";" << middleX - 8 <<
	"HText Invaders 1.0\x1b[4B\x1b[9Dby\x1b[2B\x1b[8DTony Stornetta" <<
	"\x1b[2B\x1b[28DKeys of Power: J=left K=right <space>=fire" <<
	"\x1b[2B\x1b[33DPress any key to start..." << flush;

	while (!kbhit())
	{
		switch (i++%2)
		{
		case 0:
			cout << "\x1b[" << middleY - 4 << ";" << middleX - 9 <<
"H*@*@*@*@*@*@*@*@*@\x1b[B*\x1b[B@*\x1b[B@\x1b[B\x1b[4D*@*\x1b[B\x1b[21D@*@*@*@*@*@*@*@*@*\x1b[A\x1b[21D@*@\x1b[A\x1b[4D*\x1b[A@*\x1b[A@" << flush;
			break;
		case 1:
			cout << "\x1b[" << middleY - 4 << ";" << middleX - 9 <<
"H@*@*@*@*@*@*@*@*@*\x1b[B@\x1b[B*@\x1b[B*\x1b[B\x1b[4D@*@\x1b[B\x1b[21D*@*@*@*@*@*@*@*@*@\x1b[A\x1b[21D*@*\x1b[A\x1b[4D@\x1b[A*@\x1b[A*" << flush;
			break;
		}
		stall (5000);
	}
	c = getch();
	if (c == 0x03 || c == 0x1c)
	{
		restore();
		cout << "\nQuit Program" << endl;
		exit (1);
	}
	return i;
}

int main()
{
  int screenWidth = 80, screenLength = 24;
  int done = 0;

  // Initialize the terminal
  setraw();
  srand (initScreen(screenWidth, screenLength));
  FlyingObject::setScreen (screenWidth, screenLength);
  Level::setScreen (screenWidth, screenLength);

  // Go to levels!!!
  while (!done)
  {
    Level *level;

    level = new Level();
    if (level->go() == 0)
      done = 1;
    delete (level);
  }

  cout << "\x1b[12;25H  *** YOU LOSE!!! ***  \x1b[12B\n" << endl;
  cout << "\x1b[" << screenLength+1 << ';' << (screenWidth - 30)/2 <<
    "HThanks for playing..." << flush;

  // End program
  restore();
  cout << endl << endl;
  return 0;
}
